<!-- card ข้อมูลที่อยู่ -->
<script setup lang="ts">
import { ref, onMounted, reactive } from "vue";
import { useQuasar } from "quasar";

import { useRoute } from "vue-router";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

import { AddressDataDefualt } from "@/modules//05_placement/interface/index/Main";
import type { zipCodeOption } from "@/modules/05_placement/components/PersonalDetail/profileType";
import type {
  AddressOps,
  Address as AddressType,
  optionData,
  AddressData,
} from "@/modules/05_placement/interface/index/Main";
import type { PropType } from "vue";

import HeaderTop from "@/modules/05_placement/components/PersonalDetail/Information/top.vue";

const route = useRoute();
const $q = useQuasar();
const mixin = useCounterMixin();
const { success, messageError, showLoader, hideLoader, dialogConfirm } = mixin;

/**
 * props
 */
const props = defineProps({
  statusEdit: {
    type: Boolean,
    required: true,
  },
  notiNoEdit: {
    type: Function,
    default: () => console.log("not function"),
  },
  fetch: {
    type: Function,
    default: () => console.log("not function"),
  },
  data: {
    type: Object as PropType<AddressType>,
    default: AddressDataDefualt,
  },
});
const emit = defineEmits(["update:statusEdit"]);

const myform = ref<any>(); //refForm
const edit = ref<boolean>(false); //การแก้ไข
const onEdit = ref<boolean>(false); //การแก้ไข
const addressData = ref<AddressType>(props.data); //ข้อมูลที่อยู่
//ตัวเลือกข้อมูลที่อยู่
const Ops = ref<AddressOps>({
  provinceOps: [],
  districtOps: [],
  districtCOps: [],
  subdistrictOps: [],
  subdistrictCOps: [],
});
//ข้อมูลที่อยู่
const OpsFilter = ref<AddressOps>({
  provinceOps: [],
  districtOps: [],
  districtCOps: [],
  subdistrictOps: [],
  subdistrictCOps: [],
});
//ที่อยู่ตามทะเบียนบ้าน
const registAddress = reactive<AddressData>({
  subDistrictId: "",
  zipCode: "",
  districtId: "",
  provinceId: "",
});
//ที่อยู่ปัจบัน
const currentAddress = reactive<AddressData>({
  subDistrictId: "",
  zipCode: "",
  districtId: "",
  provinceId: "",
});

/**
 * ฟังก์ชันค้นหาข้อมูลในรายการตัวเลือก
 * @param val คำค้นหา
 * @param update ฟังก์ชัน
 * @param refData ประเภทของตัวเลือก
 */
function filterSelector(val: string, update: Function, refData: string) {
  switch (refData) {
    case "provinceOps":
      update(() => {
        Ops.value.provinceOps = OpsFilter.value.provinceOps.filter(
          (v: optionData) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "districtOps":
      update(() => {
        Ops.value.districtOps = OpsFilter.value.districtOps.filter(
          (v: optionData) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "districtCOps":
      update(() => {
        Ops.value.districtCOps = OpsFilter.value.districtCOps.filter(
          (v: optionData) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "subdistrictOps":
      update(() => {
        Ops.value.subdistrictOps = OpsFilter.value.subdistrictOps.filter(
          (v: optionData) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "subdistrictCOps":
      update(() => {
        Ops.value.subdistrictCOps = OpsFilter.value.subdistrictCOps.filter(
          (v: optionData) => v.name.indexOf(val) > -1
        );
      });
      break;

    default:
      break;
  }
}

function refreshData() {
  myform.value.reset();
  if (onEdit.value) {
    dialogConfirm(
      $q,
      async () => {
        emit("update:statusEdit", false);
        await props.fetch("Address");
        fetchProvince();
        edit.value = false;
        onEdit.value = false;
      },
      `ข้อมูลมีการแก้ไข`,
      `ยืนยันยกเลิกการแก้ไขใช่หรือไม่?`
    );
  } else {
    edit.value = false;
  }
}

/**
 * ฟังก์ชันดึงข้อมูลใหม่
 */
async function getNewData() {
  await fetchProvince();
}

/**
 * ฟังก์ชันบันทึกการแก้ไข
 */
async function editData() {
  dialogConfirm($q, async () => {
    showLoader();
    const body = {
      registrationSame: addressData.value.registSame == "1",
      registrationAddress: addressData.value.registAddress,
      registrationSubDistrictId: registAddress.subDistrictId,
      registrationDistrictId: registAddress.districtId,
      registrationProvinceId: registAddress.provinceId,
      registrationZipCode: registAddress.zipCode,
      currentAddress:
        addressData.value.registSame == "1"
          ? addressData.value.registAddress
          : addressData.value.currentAddress,
      currentSubDistrictId:
        addressData.value.registSame == "1"
          ? registAddress.subDistrictId
          : currentAddress.subDistrictId,
      currentDistrictId:
        addressData.value.registSame == "1"
          ? registAddress.districtId
          : currentAddress.districtId,
      currentProvinceId:
        addressData.value.registSame == "1"
          ? registAddress.provinceId
          : currentAddress.provinceId,
      currentZipCode:
        addressData.value.registSame == "1"
          ? registAddress.zipCode
          : currentAddress.zipCode,
    };
    showLoader();
    await http
      .put(
        config.API.placementAddressId(route.params.personalId.toString()),
        body
      )
      .then(async () => {
        emit("update:statusEdit", false);
        await props.fetch("Address");
        success($q, "แก้ไขข้อมูลสำเร็จ");
        edit.value = false;
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ฟังก์ชันเลือกข้อมูลจังหวัด
 * @param e id จังหวัด
 * @param name ที่อยู่ตามทะเบียนบ้าน , ที่อยู่ปัจจุบัน
 */
async function selectProvince(e: string | null, name: string) {
  onEdit.value = true;
  if (e != null) {
    if (name == "1") {
      registAddress.subDistrictId = "";
      registAddress.zipCode = "";
      registAddress.districtId = "";
    } else {
      currentAddress.subDistrictId = "";
      currentAddress.zipCode = "";
      currentAddress.districtId = "";
    }
    myform.value.resetValidation();
    await fetchDistrict(e, name);
  }
}

/**
 * ฟังก์ชันลือกข้อมูลอำเภอ
 * @param e id อำเภอ
 * @param name ที่อยู่ตามทะเบียนบ้าน , ที่อยู่ปัจจุบัน
 */
async function selectDistrict(e: string | null, name: string) {
  onEdit.value = true;
  if (e != null) {
    if (name == "1") {
      registAddress.subDistrictId = "";
      registAddress.zipCode = "";
    } else {
      currentAddress.subDistrictId = "";
      currentAddress.zipCode = "";
    }
    myform.value.resetValidation();
    await fetchSubDistrict(e, name);
  }
}

/**
 * ฟังก์ชันเลือกข้อมูลตำบล
 * @param e id ตำบล
 * @param name ที่อยู่ตามทะเบียนบ้าน , ที่อยู่ปัจจุบัน
 */
async function selectSubDistrict(e: string | null, name: string) {
  onEdit.value = true;
  if (e != null) {
    if (name == "1") {
      const findcode = Ops.value.subdistrictOps.filter((r) => r.id == e);
      const namecode = findcode.length > 0 ? findcode[0].zipCode : "";
      registAddress.zipCode = namecode;
    } else {
      const findcode = Ops.value.subdistrictCOps.filter((r) => r.id == e);
      const namecode = findcode.length > 0 ? findcode[0].zipCode : "";
      currentAddress.zipCode = namecode;
    }
  }
}

/**
 * ฟังก์ชันดึงข้อมูลจังหวัด
 */
async function fetchProvince() {
  showLoader();
  await http
    .get(config.API.orgProvince)
    .then(async (res) => {
      const data = res.data.result;
      let option: optionData[] = [];
      data.map((r: any) => {
        option.push({ id: r.id, name: r.name });
      });
      Ops.value.provinceOps = option;
      OpsFilter.value.provinceOps = option;

      const checkRegistProvinceId = await option.find(
        (e: any) => e.id === addressData.value.registProvinceId
      );

      // ที่อยู่ถ้า id จังหวัดว่างไม่ดึงค่าอำเภอ ตำบล และรหัสไปรษณีย์
      if (
        addressData.value.registProvinceId == "" ||
        addressData.value.registProvinceId ==
          "00000000-0000-0000-0000-000000000000" ||
        !checkRegistProvinceId
      ) {
        registAddress.subDistrictId = "";
        registAddress.zipCode = "";
        registAddress.districtId = "";
      } else {
        registAddress.provinceId = await addressData.value.registProvinceId;
        registAddress.zipCode = await addressData.value.registZipCode;

        await fetchDistrict(addressData.value.registProvinceId, "1");
        if (
          addressData.value.registDistrictId != null &&
          addressData.value.registDistrictId !=
            "00000000-0000-0000-0000-000000000000"
        ) {
          await fetchSubDistrict(addressData.value.registDistrictId, "1");
        }
      }

      const checkCurrentProvinceId = await option.find(
        (e: any) => e.id === addressData.value.currentProvinceId
      );

      // ที่อยู่ปัจจุบันถ้า id จังหวัดว่างไม่ดึงค่าอำเภอ ตำบล และรหัสไปรษณีย์
      if (
        addressData.value.currentProvinceId == "" ||
        addressData.value.currentProvinceId ==
          "00000000-0000-0000-0000-000000000000" ||
        !checkCurrentProvinceId
      ) {
        currentAddress.subDistrictId = "";
        currentAddress.zipCode = "";
        currentAddress.districtId = "";
      } else {
        currentAddress.provinceId = addressData.value.currentProvinceId;
        currentAddress.zipCode = addressData.value.currentZipCode;

        await fetchDistrict(addressData.value.currentProvinceId, "2");
        if (
          addressData.value.currentDistrictId != null &&
          addressData.value.currentDistrictId !=
            "00000000-0000-0000-0000-000000000000"
        ) {
          await fetchSubDistrict(addressData.value.currentDistrictId, "2");
        }
      }
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {});
}

/**
 * ฟังก์ชันดึงข้อมูลอำเภอ
 * @param id จังหวัด
 * @param position  ที่อยู่ตามทะเบียนบ้าน , ที่อยู่ปัจจุบัน
 */
async function fetchDistrict(id: string | null, position: string) {
  if (id != null && id != "") {
    await http
      .get(config.API.orgProvince + `/${id}`)
      .then(async (res) => {
        const data = res.data.result.districts;
        let option: optionData[] = [];
        data.map((r: any) => {
          option.push({ id: r.id, name: r.name });
        });
        if (position == "1") {
          Ops.value.districtOps = option;
          OpsFilter.value.districtOps = option;

          // ที่อยู่ เช็คอำเภอว่ามี id ใน array ไหม ถ้ามีค่อยกำหนดค่าไปในตัวแปรใหม่เพิ่มแสดงผล
          const checkRegistDistrictId = option.find(
            (e: any) => e.id === addressData.value.registDistrictId
          );

          if (checkRegistDistrictId) {
            registAddress.districtId = addressData.value.registDistrictId;
          }
        } else {
          Ops.value.districtCOps = option;
          OpsFilter.value.districtCOps = option;

          // ที่อยู่ปัจจุบัน เช็คอำเภอว่ามี id ใน array ไหม ถ้ามีค่อยกำหนดค่าไปในตัวแปรใหม่เพิ่มแสดงผล
          const checkCurrentDistrictId = await option.find(
            (e: any) => e.id === addressData.value.currentDistrictId
          );
          if (checkCurrentDistrictId) {
            currentAddress.districtId = addressData.value.currentDistrictId;
          }
        }
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {});
  }
}

/**
 * ฟังก์ชันดึงข้อมูลตำบล
 * @param id อำเภอ
 * @param position  ที่อยู่ตามทะเบียนบ้าน , ที่อยู่ปัจจุบัน
 */
async function fetchSubDistrict(id: string | null, position: string) {
  if (id != null && id != "") {
    await http
      .get(config.API.orgDistrict + `/${id}`)
      .then(async (res) => {
        const data = res.data.result.subDistricts;
        let option: zipCodeOption[] = [];
        data.map((r: any) => {
          option.push({
            id: r.id,
            name: r.name,
            zipCode: r.zipCode,
          });
        });
        if (position == "1") {
          Ops.value.subdistrictOps = option;
          OpsFilter.value.subdistrictOps = option;

          // ที่อยู่ เช็คตำบลว่ามี id ใน array ไหม ถ้ามีค่อยกำหนดค่าไปในตัวแปรใหม่เพิ่มแสดงผล
          const checkRegistSubDistrictId = await option.find(
            (e: any) => e.id === addressData.value.registSubDistrictId
          );
          if (checkRegistSubDistrictId) {
            registAddress.subDistrictId = addressData.value.registSubDistrictId;
          }
        } else {
          Ops.value.subdistrictCOps = option;
          OpsFilter.value.subdistrictCOps = option;

          // ที่อยู่ปัจจุบัน เช็คตำบลว่ามี id ใน array ไหม ถ้ามีค่อยกำหนดค่าไปในตัวแปรใหม่เพิ่มแสดงผล
          const checkCurrentSubDistrictId = await option.find(
            (e: any) => e.id === addressData.value.currentSubDistrictId
          );
          if (checkCurrentSubDistrictId) {
            currentAddress.subDistrictId =
              addressData.value.currentSubDistrictId;
          }
        }
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  }
}

/**
 * ฟังก์ชันการแก้ไขข้อมูล
 */
function changeBtn() {
  if (edit.value == true) {
    if (props.statusEdit === true) {
      props.notiNoEdit();
    } else {
      emit("update:statusEdit", true);
    }
  } else {
    emit("update:statusEdit", false);
  }
}

/**
 * ฟังก์ชันแก้ไขข้อมูล
 */
function checkEdit() {
  onEdit.value = true;
}

/**
 * ฟังก์ชันสำหรับคืนค่าชื่อคลาสตามค่าที่กำหนด
 * @param val ค่าที่ใช้กำหนดคลาส
 */
function getClass(val: boolean) {
  return {
    "full-width inputgreen cursor-pointer": val,
    "full-width cursor-pointer": !val,
  };
}

/**
 * ทำงานเมื่อมีการเรียกใช้ Components
 */
onMounted(async () => {
  await getNewData();
  emit("update:statusEdit", false);
});
</script>

<template>
  <q-card class="col-12 q-px-lg q-py-md q-mt-md no-border">
    <q-form ref="myform" greedy @submit.prevent @validation-success="editData">
      <HeaderTop
        v-model:edit="edit"
        header="ข้อมูลที่อยู่"
        icon="mdi-map-marker"
        :history="false"
        :changeBtn="changeBtn"
        :disable="statusEdit"
        :cancel="refreshData"
      />

      <div class="row col-12 items-top q-col-gutter-x-xs q-col-gutter-y-xs">
        <div class="col-xs-12">
          <q-input
            :class="getClass(edit)"
            hide-bottom-space
            :outlined="edit"
            dense
            lazy-rules
            type="textarea"
            autogrow
            :readonly="!edit"
            :borderless="!edit"
            v-model="addressData.registAddress"
            :rules="[(val: string) => !!val || `${'กรุณากรอก ที่อยู่ตามทะเบียนบ้าน'}`]"
            :label="`${'ที่อยู่ตามทะเบียนบ้าน'}`"
            @update:modelValue="checkEdit"
          />
        </div>
        <div class="col-xs-6 col-sm-3 col-md-3">
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือก จังหวัด'}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="registAddress.provinceId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.provinceOps"
            option-value="id"
            :label="`${'จังหวัด'}`"
            @update:model-value="(value: string) => selectProvince(value, '1')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'provinceOps'
              )"
          />
        </div>
        <div class="col-xs-6 col-sm-3 col-md-3">
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือกแขวง/ตำบล'}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="registAddress.districtId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.districtOps"
            option-value="id"
            :label="`${'เขต/อำเภอ'}`"
            @update:model-value="(value: string) => selectDistrict(value, '1')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'districtOps'
              )"
          />
        </div>
        <div class="col-xs-6 col-sm-3 col-md-3">
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือกแขวง/ตำบล '}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="registAddress.subDistrictId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.subdistrictOps"
            option-value="id"
            :label="`${'แขวง/ตำบล '}`"
            @update:model-value="(value: string) => selectSubDistrict(value, '1')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'subdistrictOps'
              )"
          />
        </div>
        <div class="col-xs-6 col-sm-3 col-md-3">
          <q-input
            :class="getClass(edit)"
            hide-bottom-space
            dense
            lazy-rules
            readonly
            borderless
            v-model="registAddress.zipCode"
            :style="!edit ? '' : 'padding:0 12px;'"
            :label="`${'รหัสไปรษณีย์'}`"
          />
        </div>
        <div class="col-12 q-pt-lg"><q-separator /></div>
        <div class="col-xs-12 q-gutter-sm items-center flex q-my-sm">
          <label class="text-bold"
            >ที่อยู่ปัจจุบันตรงกับที่อยู่ตามทะเบียนบ้าน</label
          >
          <q-radio
            v-model="addressData.registSame"
            checked-icon="task_alt"
            unchecked-icon="panorama_fish_eye"
            val="1"
            label="ใช่"
            dense
            :disable="!edit"
            @update:modelValue="checkEdit"
          />
          <q-radio
            v-model="addressData.registSame"
            checked-icon="task_alt"
            unchecked-icon="panorama_fish_eye"
            val="0"
            label="ไม่"
            dense
            @update:modelValue="checkEdit"
            :disable="!edit"
          />
        </div>

        <div class="col-xs-12" v-if="addressData.registSame == '0'">
          <q-input
            :class="getClass(edit)"
            hide-bottom-space
            :outlined="edit"
            dense
            lazy-rules
            type="textarea"
            @update:modelValue="checkEdit"
            autogrow
            :readonly="!edit"
            :borderless="!edit"
            v-model="addressData.currentAddress"
            :rules="[(val: string) => !!val || `${'กรุณากรอก ที่อยู่ปัจจุบัน'}`]"
            :label="`${'ที่อยู่ปัจจุบัน'}`"
          />
        </div>
        <div
          class="col-xs-6 col-sm-3 col-md-3"
          v-if="addressData.registSame == '0'"
        >
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือก จังหวัด'}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="currentAddress.provinceId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.provinceOps"
            option-value="id"
            :label="`${'จังหวัด'}`"
            @update:model-value="(value: string) => selectProvince(value, '2')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'provinceOps'
              )"
          />
        </div>
        <div
          class="col-xs-6 col-sm-3 col-md-3"
          v-if="addressData.registSame == '0'"
        >
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือกแขวง/ตำบล'}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="currentAddress.districtId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.districtCOps"
            option-value="id"
            :label="`${'เขต/อำเภอ'}`"
            @update:model-value="(value: string) => selectDistrict(value, '2')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'districtCOps'
              )"
          />
        </div>
        <div
          class="col-xs-6 col-sm-3 col-md-3"
          v-if="addressData.registSame == '0'"
        >
          <q-select
            :hide-dropdown-icon="!edit"
            hide-bottom-space
            :class="getClass(edit)"
            :readonly="!edit"
            :borderless="!edit"
            :rules="[(val: string) => !!val || `${'กรุณาเลือกแขวง/ตำบล'}`]"
            :outlined="edit"
            dense
            lazy-rules
            v-model="currentAddress.subDistrictId"
            emit-value
            map-options
            option-label="name"
            :options="Ops.subdistrictCOps"
            option-value="id"
            :label="`${'แขวง/ตำบล '}`"
            @update:model-value="(value: string) => selectSubDistrict(value, '2')"
            use-input
            input-debounce="0"
            @filter="(inputValue: string,
              doneFn: Function) => filterSelector(inputValue, doneFn, 'subdistrictCOps'
              )"
          />
        </div>
        <div
          class="col-xs-6 col-sm-3 col-md-3"
          v-if="addressData.registSame == '0'"
        >
          <q-input
            :class="getClass(edit)"
            hide-bottom-space
            dense
            lazy-rules
            readonly
            borderless
            v-model="currentAddress.zipCode"
            :style="!edit ? '' : 'padding:0 12px;'"
            :label="`${'รหัสไปรษณีย์'}`"
          />
        </div>
      </div>
    </q-form>
  </q-card>
</template>
